/*
 * This file was generated by qdbusxml2cpp version 0.7
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This was an auto-generated file.
 */

#include "adaptor.h"
#include <QtCore/QMetaObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>

/*
 * Implementation of adaptor class Provisioner1Adaptor
 */

Provisioner1Adaptor::Provisioner1Adaptor(
	Oscl::Qt::DBus::BlueZ::
	Mesh::Provisioner1::ContextApi&	contextApi,
	const QDBusConnection&			bus,
	QObject*						parent
	):
		QDBusAbstractAdaptor(parent),
		_contextApi(contextApi),
		_bus(bus)
		{
    setAutoRelaySignals(true);
	}

Provisioner1Adaptor::~Provisioner1Adaptor() {
	}

void Provisioner1Adaptor::AddNodeComplete(
		const QByteArray&	uuid,
		ushort				unicast,
		uchar				count,
		const QDBusMessage&	message
		) {

	if(uuid.count() != 16){
		QDBusMessage
		error	= message.createError(
					"org.bluez.mesh.Error.InvalidArguments",
					"uuid must be exactly 16 octets."
					);
		_bus.send(error);
		return;
		}

	_contextApi.addNodeCompleteReceived(
		(const uint8_t*)uuid.constData(),
		unicast,
		count
		);
	}

void Provisioner1Adaptor::AddNodeFailed(
		const QByteArray&	uuid,
		const QString&		reason,
		const QDBusMessage&	message
		) {

	if(uuid.count() != 16){
		QDBusMessage
		error	= message.createError(
					"org.bluez.mesh.Error.InvalidArguments",
					"uuid must be exactly 16 octets."
					);
		_bus.send(error);
		return;
		}

	_contextApi.addNodeFailedReceived(
		(const uint8_t*)uuid.constData(),
		reason.toLatin1()
		);
	}

ushort Provisioner1Adaptor::RequestProvData(
		uchar				count,
		const QDBusMessage&	message,
		ushort&				unicast
		) {

	return _contextApi.requestProvDataReceived(
			count,
			unicast
			);
	}

void Provisioner1Adaptor::ScanResult(
		short	rssi,
		const QByteArray&	data,
		const QVariantMap&	options,
		const QDBusMessage&	message
		) {

	// There are currently no options defined.

	unsigned	nData	= data.count();

	_contextApi.scanResultReceived(
		rssi,
		nData,
		data.constData()
		);
	}

